---

variables:
  GROUP_NAME: "aka.namerec"
  PROJECT_NAME: "simple_cms"

# This is a base job template for all `docker`-based jobs. It won't be executed.
.docker:
  image: docker:latest
  variables:
    # When using dind, it's wise to use the overlayfs driver for
    # improved performance:
    DOCKER_DRIVER: overlay2
    REGISTRY: "registry.gitlab.com"
    CONTAINER_RELEASE_IMAGE: "$REGISTRY/$GROUP_NAME/$PROJECT_NAME:latest"
  services:
    - docker:dind
  before_script:
    # Installing global dependencies:
    - apk update && apk upgrade
    - apk add python3 python3-dev py3-pip git build-base
    - pip3 install dump-env docker-image-size-limit 'docker-compose<1.24'
    # Creating `.env` configuration file:
    - dump-env -t config/.env.template -p 'SECRET_'
      --strict=SECRET_DJANGO_SECRET_KEY > config/.env
    # Login into Docker registry:
    - docker login -u gitlab-ci-token -p "$CI_JOB_TOKEN" "$REGISTRY"
    # Debug information:
    - docker info && docker-compose --version && git --version

# Testing application:
test:
  extends: .docker
  stage: test
  script:
    - docker-compose -f docker-compose.yml
      -f docker/docker-compose.prod.yml config --quiet
    - docker-compose run --rm web sh ./docker/ci.sh
    - disl "${PROJECT_NAME}_web:latest" 650MiB
  coverage: '/[\d\.]+\%\s*$/'
  only:
    - merge_requests

# Releasing image, when in `master` branch,
# can be replaced with `kira-release` bot:
# https://github.com/wemake-services/kira-release
release-image:
  extends: .docker
  stage: deploy
  script:
    - docker build -t "$CONTAINER_RELEASE_IMAGE"
      --build-arg DJANGO_ENV=production -f docker/django/Dockerfile .
    - docker push "$CONTAINER_RELEASE_IMAGE"
  only:
    - master
  environment:
    name: production  # used to track time with 'cycle analytics'

pages:
  stage: .post
  image: docker:latest
  script:
    - apk update && apk upgrade
    - apk add make
    - cd docs
    - make html
    - cd ..
    - mv docs/_build/html public/
  artifacts:
    paths:
      - public
  only:
    - master
